OPT PREPROCESS

/*
 *
 *        Modified HEAVILY from rkmbutclass source code.
 *
 */

MODULE	'graphics/view'
MODULE 'utility',
			 'amigalib/boopsi',
			 'tools/installhook',
			 'devices/inputevent',
			 'graphics/rastport',
			 'intuition/cghooks',
			 'intuition/classes',
			 'intuition/classusr',
			 'intuition/gadgetclass',
			 'intuition/icclass',
			 'intuition/imageclass',
			 'intuition/intuition',
			 'intuition/screens',
			 'utility/tagitem'

MODULE	'graphics/text'
MODULE	'mod/fonts'
MODULE	'gadgets/popup'
MODULE	'exec/memory'

MODULE	'dos/dos','dos/dosextens','dos/dosasl'
MODULE	'libraries/gadtools'
MODULE	'exec/lists','exec/nodes'
MODULE	'amigalib/lists','mod/lists'
MODULE	'mod/compare'
MODULE	'amigalib/lists'

MODULE	'popup'
MODULE	'gadgets/popup'
MODULE	'chunkyimage','class/chunkyimage'
MODULE	'exec/nodes','exec/lists'
MODULE	'intuition/intuition','intuition/imageclass','intuition/classes','intuition/gadgetclass','intuition/classusr','intuition/icclass'
MODULE	'libraries/gadtools'
MODULE	'graphics/rastport'
MODULE	'utility','utility/tagitem'

PROC main() HANDLE
	DEF drawinfo,scr=0
	DEF objlist=0:PTR TO mlh
	DEF objlist2=0
	DEF objlist3=0:PTR TO mlh
	DEF objlist4=0:PTR TO mlh
	DEF i,ii
	DEF w=NIL:PTR TO window, rkmbutcl=NIL
	DEF	integer1=NIL:PTR TO gadget
	DEF	integer2=NIL:PTR TO gadget
	DEF	integer3=NIL:PTR TO gadget
	DEF	integer4=NIL:PTR TO gadget
	DEF but1=NIL:PTR TO gadget
	DEF but2=NIL:PTR TO gadget
	DEF but3=NIL:PTR TO gadget
	DEF but4=NIL:PTR TO gadget
	DEF chunkyimage_class
	DEF fillrect=0
	DEF imobj=0
	DEF obj:PTR TO image
	DEF obj2:PTR TO image
	DEF obj3
	DEF mchunk:PTR TO image
	DEF node:PTR TO imagenode
	DEF strings[250]:LIST
	DEF bases[250]:LIST
	DEF string[500]:STRING
	DEF apath=NIL:PTR TO anchorpath
	DEF fileinfo=NIL:PTR TO fileinfoblock
	DEF	achain=NIL:PTR TO achain
	DEF err,first
	DEF nummuiobjs=0
	DEF propg:PTR TO gadget
	DEF propg2:PTR TO gadget
	DEF propg3:PTR TO gadget
	DEF propg4:PTR TO gadget
	DEF propg5:PTR TO gadget
	DEF propg6:PTR TO gadget
	DEF propg7:PTR TO gadget
	DEF model
	DEF p2i1
	DEF p2i2
	DEF p2i3
	DEF p2i4
	DEF p2b1
	DEF p2b2
	DEF p2b3
	DEF p2b4

	DEF class,code,qual,iaddr

	popupbase:=OpenLibrary('gadgets/popup.gadget',3)
	IF popupbase=0
		WriteF('Need popup.gadget v3!\n')
		Raise(0)
	ENDIF
	chunkyimagebase:=OpenLibrary('chunkyimage.class',1)
	IF chunkyimagebase=0
		WriteF('Need chunkyimage.class v1!\n')
		Raise(0)
	ENDIF
	utilitybase:=OpenLibrary('utility.library', 37)
	IF utilitybase=0
		WriteF('Need utility.library v37!\n')
		Raise(0)
	ENDIF

	FOR i:=0 TO 249
		strings[i]:=0
	ENDFOR
	i:=0
	first:=0
	err:=0
	apath:=New(SIZEOF anchorpath)
	WHILE err=NIL
		IF first=FALSE
			err:=MatchFirst('MUI:Libs/images/#?.image',apath)
			first:=TRUE
		ELSE
			err:=MatchNext(apath)
		ENDIF
		IF err=NIL
			achain:=apath.last
			IF (achain)
				fileinfo:=achain.info
				IF (fileinfo)
					IF (fileinfo.direntrytype)<0
						strings[i]:=String(StrLen(fileinfo.filename))
						StrCopy(strings[i],fileinfo.filename,StrLen(fileinfo.filename)-6)
						StrCopy(string,'images/',ALL)
						StrAdd(string,strings[i],ALL)
						StrAdd(string,'.image',ALL)
						bases[i]:=OpenLibrary(string,0)
						i:=i+1
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDWHILE
	nummuiobjs:=i

	IF apath THEN MatchEnd(apath)
	IF apath THEN Dispose(apath)
	
	NEW objlist,objlist3,objlist4
	newList(objlist)
	newList(objlist3)
	newList(objlist4)

	scr:=LockPubScreen('Workbench')
	drawinfo:=GetScreenDrawInfo(scr)

	w:=OpenWindowTagList(NIL,
		 [WA_FLAGS,	WFLG_DEPTHGADGET OR WFLG_DRAGBAR OR
			WFLG_CLOSEGADGET OR WFLG_SIZEGADGET,
			WA_IDCMP,	IDCMP_CLOSEWINDOW OR IDCMP_IDCMPUPDATE,
			WA_SIMPLEREFRESH,TRUE,
			WA_WIDTH,	420,
			WA_HEIGHT, 200,
			WA_LEFT,120,
			WA_TOP,200,
			NIL])

	IF rkmbutcl:=InitPopUpClass()
	IF chunkyimage_class:=Init_chunkyiclass()

	/* Add some funky rectangles of varying sizes, positions and colors */

	FOR i:=0 TO 4
		obj:=NewObjectA(NIL,'fillrectclass',
			 [IA_WIDTH,(4+(i*4)),
				IA_HEIGHT,(20-(i*4)),
				IA_FGPEN,(i),
				IA_BGPEN,(255-i),
				IA_MODE,RP_JAM2,
				IA_APATTERN,[%01010101010101010101010101010101,%10101010101010101010101010101010],
				IA_APATSIZE,2,
				TAG_END])
		obj2:=NewObjectA(NIL,'fillrectclass',
			 [IA_WIDTH,(20-(i*4)),
				IA_HEIGHT,(4+(i*4)),
				IA_FGPEN,i,
				IA_BGPEN,(255-i),
				IA_MODE,RP_JAM2,
				IA_APATTERN,[%01010101010101010101010101010101,%10101010101010101010101010101010],
				IA_APATSIZE,2,
				TAG_END])
		AddObjectToList(objlist,obj,FRAME_DEFAULT,obj2,FRAME_DEFAULT,BACKGROUNDPEN)
	ENDFOR

	/* Add 10 sysiclass images, one of each */

	FOR i:=0 TO $11
		IF ((i<>4) AND ((i<6) OR (i>9)))
			obj2:=NewObjectA(NIL,'sysiclass',
			 [IA_WIDTH,(24),
				IA_HEIGHT,(24),
				SYSIA_WHICH,i,
				SYSIA_DRAWINFO,drawinfo,
				TAG_END])
			AddObjectToList(objlist,obj2,0,0,0,FILLPEN)
		ENDIF
	ENDFOR

	/* Add a simple "chunkyiclass" image */

	obj3:=NewObjectA(chunkyimage_class,NIL,
	 [CHUNKYIA_SCREEN,scr,
		CHUNKYIA_PALETTE,{palette},
		CHUNKYIA_PRECISION,PRECISION_GUI,
		IA_DATA,{imagedata},
		TAG_END])
	AddObjectToList(objlist,obj3,0,0,2,SHINEPEN)

	/* Add a simple TOPAZ-8 text image */

	node:=AddTextToList(objlist,'Text',['topaz.font',9,FSF_ITALIC OR FSF_UNDERLINED,0]:textattr,drawinfo)
	node.frametype:=FRAME_BUTTON  ->	It's OKAY to modify individual nodes'
																->	PUBLIC fields *before* creating the popup gadget.
																->  Even those images created with "AddTextToList".
																->  It's even possible to modify "palette" objects,
																->  but more difficult as a complete list is returned.

	/* Add some simple rectangles */

	FOR i:=0 TO 4
		obj:=NewObjectA(NIL,'fillrectclass',
			[IA_WIDTH,(16),
			IA_HEIGHT,(16),
			IA_FGPEN,i,
			IA_BGPEN,i,
			IA_MODE,RP_JAM2,
			IA_APATTERN,[$FFFFFFFF,$FFFFFFFF],
			IA_APATSIZE,2,
			TAG_END])
		AddObjectToList(objlist,obj,0,0,3,FILLPEN)
	ENDFOR


	integer1:=NewObjectA(NIL, 'strgclass',
											 [GA_ID,						2,
												GA_LEFT,					w.borderleft+5,
												GA_TOP,						w.bordertop+5,
												GA_WIDTH,					40,
												GA_HEIGHT,				20,
												STRINGA_LONGVAL,	0,
												STRINGA_MAXCHARS, 5,
												NIL])

		but1:=NewObjectA(rkmbutcl, NIL,
									 [GA_ID,						3,
										GA_LEFT,					integer1.leftedge+integer1.width+3,
										GA_TOP,						integer1.topedge,
										GA_WIDTH,					15,-> These will be expanded upon if neccessary!
										GA_HEIGHT,				15,->                 """"
										GA_PREVIOUS,			integer1,
										PUA_POPUPARROW,0,
										ICA_MAP,					[PUA_ACTIVE, STRINGA_LONGVAL, NIL],
										ICA_TARGET,				integer1,
->										ICA_TARGET,ICTARGET_IDCMP,
->										ICA_MAP,					[PUA_ACTIVE, ICSPECIAL_CODE, NIL],
										PUA_WINDOWBORDER,	FRAME_ICONDROPBOX,
										PUA_GADGETBORDER,	0,
										PUA_ROWS,5,
										PUA_COLUMNS,				5,
										PUA_OBJECTS,				objlist,
										PUA_WINDOWSPACING,TRUE,
										PUA_IMAGESPACING,TRUE,
										PUA_CENTERIMAGES,0,
										PUA_CENTERGADGETIMAGE,0,
										PUA_AUTOGADGETRESIZE,TRUE,
										PUA_POPUPMODE,PUPOPUPMODE_NORMAL,
										NIL])

		integer2:=NewObjectA(NIL, 'strgclass',
											 [GA_ID,						4,
												GA_LEFT,					integer1.leftedge,
												GA_TOP,						bigger(but1.topedge+but1.height,integer1.topedge+integer1.height)+8,
												GA_WIDTH,					40,
												GA_HEIGHT,				20,
												STRINGA_LONGVAL,	0,
												STRINGA_MAXCHARS, 5,
												GA_PREVIOUS,			but1,
												NIL])

		objlist2:=BuildPalette(0,15,24,20)		->	This returns a LIST struct, to be given back to
																					->	"DisposePalette".  You can still use
																					->	AddObjectToList() with this list.  And, if
																					->	you add your own imagenodes, make sure to Remove()
																					->	them before using DisposePalette()!

		but2:=NewObjectA(rkmbutcl, NIL,
									 [GA_ID,								5,
										GA_LEFT,							but1.leftedge,
										GA_TOP,								integer2.topedge,
										GA_WIDTH,10,
										GA_HEIGHT,10,
										GA_PREVIOUS,					integer2,
->										GA_DISABLED,			TRUE,
										ICA_MAP,				 [PUA_ACTIVE, STRINGA_LONGVAL, NIL],
										ICA_TARGET,			 integer2,
->										ICA_TARGET,ICTARGET_IDCMP,
->										ICA_MAP,					[PUA_ACTIVE, ICSPECIAL_CODE, NIL],
										PUA_POPUPARROW,PUARROW_TINY,
										PUA_GADGETBORDER,FRAME_BUTTON,
										PUA_WINDOWBORDER,FRAME_DEFAULT,
										PUA_ROWS,4,
										PUA_COLUMNS,4,
										PUA_OBJECTS,objlist2,
										PUA_AUTOGADGETRESIZE,TRUE,
										PUA_CENTERIMAGES,TRUE,
										PUA_CENTERGADGETIMAGE,TRUE,
										PUA_WINDOWSPACING,TRUE,
										PUA_POPUPMODE,PUPOPUPMODE_NORMAL,
										NIL])


		integer3:=NewObjectA(NIL, 'strgclass',
											 [GA_ID,						6,
												GA_LEFT,					integer2.leftedge,
												GA_TOP,						bigger(but2.topedge+but2.height,integer2.topedge+integer2.height)+8,
												GA_WIDTH,				 40,
												GA_HEIGHT,				20,
												STRINGA_LONGVAL,	0,
												STRINGA_MAXCHARS, 5,
->												ICA_TARGET,ICTARGET_IDCMP,
												GA_PREVIOUS,but2,
												NIL])


		node:=AddTextToList(objlist3,'Font Test',['topaz.font',11,FSF_ITALIC OR FSF_BOLD,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'XEN 11pt',['xen.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Diamond 12pt',['diamond.font',12,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Garnet 16pt',['garnet.font',16,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Opal 12pt',['opal.font',12,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Granite 11pt',['granite.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Ruby 12pt',['ruby.font',12,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'xHelvetica 11pt',['xhelvetica.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'DPaint 8pt',['dpaint.font',8,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'E 11pt',['e.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'ELSE 11pt',['else.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Topaz 11pt',['topaz.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Quartz 11pt',['quartz.font',11,0,0]:textattr,drawinfo)
		node:=AddTextToList(objlist3,'Civilization 8pt',['civ.font',8,0,0]:textattr,drawinfo)

		but3:=NewObjectA(rkmbutcl, NIL,
									 [GA_ID,						7,
										GA_LEFT,					but2.leftedge,
										GA_TOP,						integer3.topedge,
										GA_WIDTH,20,
										GA_HEIGHT,20,
										GA_PREVIOUS,			integer3,
->										GA_DISABLED,			TRUE,
										ICA_MAP,					[PUA_ACTIVE, STRINGA_LONGVAL, NIL],
										ICA_TARGET,				integer3,
->										ICA_TARGET,ICTARGET_IDCMP,
->										ICA_MAP,					[PUA_ACTIVE, ICSPECIAL_CODE, NIL],
										PUA_POPUPARROW,PUARROW_POPUP,
										PUA_GADGETBORDER,FRAME_BUTTON,
										PUA_WINDOWBORDER,FRAME_RIDGE,
										PUA_ROWS,10,
										PUA_COLUMNS,10,
										PUA_OBJECTS,objlist3,
										PUA_WINDOWSPACING,TRUE,
										PUA_AUTOGADGETRESIZE,TRUE,
										PUA_CENTERIMAGES,TRUE,
										PUA_CENTERGADGETIMAGE,TRUE,
										PUA_POPUPMODE,PUPOPUPMODE_NORMAL,
										GA_RELVERIFY,TRUE,
										NIL])
		GetAttr(PUA_NUMBEROFOBJECTS,but3,{obj})
		SetAttrsA(but3,[PUA_ROWS,((obj+1)/2),PUA_COLUMNS,2,TAG_END])

		integer4:=NewObjectA(NIL, 'strgclass',
											 [GA_ID,						8,
												GA_LEFT,					integer3.leftedge,
												GA_TOP,						bigger(but3.topedge+but3.height,integer3.topedge+integer3.height)+8,
												GA_WIDTH,					40,
												GA_HEIGHT,				20,
												STRINGA_LONGVAL,	0,
												STRINGA_MAXCHARS, 5,
												GA_PREVIOUS,but3,
												NIL])

		FOR i:=0 TO 249
				IF strings[i]
					obj:=NewObjectA(NIL,strings[i],
						 [IA_WIDTH,18,
							IA_HEIGHT,18,
							TAG_END])
					AddObjectToList(objlist4,obj,FRAME_DEFAULT,0,FRAME_DEFAULT,FILLPEN)
				ENDIF
		ENDFOR

		err:=1;first:=1

		WHILE ((err*first)<nummuiobjs)
			IF err<first
				err:=err+1
			ELSE
				first:=first+1
			ENDIF
		ENDWHILE

		mchunk:=NewObjectA(chunkyimage_class,NIL,
			 [CHUNKYIA_SCREEN,scr,
				CHUNKYIA_PALETTE,{mcolordata},
				CHUNKYIA_PRECISION,PRECISION_GUI,
				IA_DATA,{mimagedata1},
				CHUNKYIA_SELECTEDDATA,{mimagedata2},
				IA_BGPEN,0,
				CHUNKYIA_SELECTEDBGPEN,0,
				TAG_END])


		but4:=NewObjectA(rkmbutcl, NIL,
									 [GA_ID,						9,
										GA_LEFT,					but3.leftedge,
										GA_TOP,						integer4.topedge,
										GA_WIDTH,10,
										GA_HEIGHT,10,
										GA_PREVIOUS,			integer4,
										GA_IMAGE,mchunk,
										GA_RELVERIFY,TRUE,
->										GA_DISABLED,			TRUE,
										ICA_MAP,					[PUA_ACTIVE, STRINGA_LONGVAL, NIL],
										ICA_TARGET,				integer4,
->										ICA_TARGET,ICTARGET_IDCMP,
	->									ICA_MAP,					[PUA_ACTIVE, ICSPECIAL_CODE, NIL],
										PUA_POPUPARROW,PUARROW_TINY,
										PUA_GADGETBORDER,FRAME_BUTTON,
										PUA_WINDOWBORDER,FRAME_BUTTON,
										PUA_WINDOWSPACING,TRUE,
										PUA_IMAGESPACING,TRUE,
										PUA_ROWS,first,
										PUA_COLUMNS,err,
										PUA_OBJECTS,objlist4,
										PUA_AUTOGADGETRESIZE,TRUE,
										PUA_POPUPMODE,PUPOPUPMODE_RIGHTSIDE,
										NIL])

/*
		p2i1:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,integer1,
				ICA_MAP,[PGA_TOP,STRINGA_LONGVAL,TAG_END],
				TAG_END])
		p2i2:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,integer2,
				ICA_MAP,[PGA_TOP,STRINGA_LONGVAL,TAG_END],
				TAG_END])
		p2i3:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,integer3,
				ICA_MAP,[PGA_TOP,STRINGA_LONGVAL,TAG_END],
				TAG_END])
		p2i4:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,integer4,
				ICA_MAP,[PGA_TOP,STRINGA_LONGVAL,TAG_END],
				TAG_END])
*/
		p2b1:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,PUA_ACTIVE,TAG_END],
				TAG_END])
		p2b2:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,but2,
				ICA_MAP,[PGA_TOP,PUA_ACTIVE,TAG_END],
				TAG_END])
		p2b3:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,but3,
				ICA_MAP,[PGA_TOP,PUA_ACTIVE,TAG_END],
				TAG_END])
		p2b4:=NewObjectA(NIL,'icclass',
			 [ICA_TARGET,but4,
				ICA_MAP,[PGA_TOP,PUA_ACTIVE,TAG_END],
				TAG_END])

		model:=NewObjectA(NIL,'modelclass',
			 [ICA_TARGET,ICTARGET_IDCMP,
				ICA_MAP,[PGA_TOP,PUA_ACTIVE,TAG_END],
				TAG_END])
		doMethodA(model,[OM_ADDMEMBER,p2b1]:LONG)
		doMethodA(model,[OM_ADDMEMBER,p2b2]:LONG)
		doMethodA(model,[OM_ADDMEMBER,p2b3]:LONG)
		doMethodA(model,[OM_ADDMEMBER,p2b4]:LONG)
			 

		propg:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,bigger(bigger(bigger(but1.width,but2.width),but3.width),but4.width)+8+but1.leftedge,
				GA_TOP,but1.topedge,
				GA_WIDTH,16,
				GA_HEIGHT,(but4.topedge+but4.height)-but1.topedge,
				GA_PREVIOUS,but4,
				ICA_TARGET,model,
				PGA_TOP,0,
				PGA_VISIBLE,1,
				PGA_TOTAL,40,
				TAG_END])


		propg2:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg.leftedge+propg.width+8,
				GA_TOP,propg.topedge,
				GA_WIDTH,propg.width,
				GA_HEIGHT,propg.height,
				GA_PREVIOUS,propg,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,PUA_POPUPARROW,NIL],
				PGA_TOP,PUARROW_NONE,
				PGA_VISIBLE,1,
				PGA_TOTAL,3,
				TAG_END])

		propg3:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg2.leftedge+propg2.width+8,
				GA_TOP,propg2.topedge,
				GA_WIDTH,propg2.width,
				GA_HEIGHT,propg2.height,
				GA_PREVIOUS,propg2,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,PUA_GADGETBORDER,NIL],
				PGA_TOP,0,
				PGA_VISIBLE,1,
				PGA_TOTAL,5,
				TAG_END])

		propg4:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg3.leftedge+propg3.width+8,
				GA_TOP,propg3.topedge,
				GA_WIDTH,propg3.width,
				GA_HEIGHT,propg3.height,
				GA_PREVIOUS,propg3,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,PUA_IMAGESPACING,NIL],
				PGA_TOP,0,
				PGA_VISIBLE,1,
				PGA_TOTAL,2,
				TAG_END])

		propg5:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg4.leftedge+propg4.width+8,
				GA_TOP,propg4.topedge,
				GA_WIDTH,propg4.width,
				GA_HEIGHT,propg4.height,
				GA_PREVIOUS,propg4,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,PUA_CENTERIMAGES,NIL],
				PGA_TOP,0,
				PGA_VISIBLE,1,
				PGA_TOTAL,2,
				TAG_END])

		propg6:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg5.leftedge+propg5.width+8,
				GA_TOP,propg5.topedge,
				GA_WIDTH,propg5.width,
				GA_HEIGHT,propg5.height,
				GA_PREVIOUS,propg5,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,GA_DISABLED,NIL],
				PGA_TOP,0,
				PGA_VISIBLE,1,
				PGA_TOTAL,2,
				TAG_END])

		propg7:=NewObjectA(NIL,'propgclass',
			 [GA_ID,20,
				GA_LEFT,propg6.leftedge+propg6.width+8,
				GA_TOP,propg6.topedge,
				GA_WIDTH,propg6.width,
				GA_HEIGHT,propg6.height,
				GA_PREVIOUS,propg6,
				ICA_TARGET,but1,
				ICA_MAP,[PGA_TOP,GA_LEFT,NIL],
				PGA_TOP,but1.leftedge,
				PGA_VISIBLE,but1.leftedge,
				PGA_TOTAL,but1.leftedge+100,
				TAG_END])

		SetAttrsA(integer1,[ICA_MAP,[STRINGA_LONGVAL,PUA_ACTIVE,TAG_END],ICA_TARGET,but1,TAG_END])
		SetGadgetAttrsA(integer2,w,0,[ICA_MAP,[STRINGA_LONGVAL,PUA_ACTIVE,TAG_END],ICA_TARGET,but2,TAG_END])
		SetAttrsA(integer3,[ICA_MAP,[STRINGA_LONGVAL,PUA_ACTIVE,TAG_END],ICA_TARGET,but3,TAG_END])
		SetAttrsA(integer4,[ICA_MAP,[STRINGA_LONGVAL,PUA_ACTIVE,TAG_END],ICA_TARGET,but4,TAG_END])


		AddGList(w, integer1, -1, -1, NIL)
		RefreshGList(integer1, w, NIL, -1)

		SetWindowTitles(w, '#,->,border,ispace,center,disable,leftedge', NIL)

/*
		Delay(15)
		SetGadgetAttrsA(but1,w,0,[GA_DISABLED,FALSE,TAG_END])
		Delay(5)
		SetGadgetAttrsA(but2,w,0,[GA_DISABLED,FALSE,TAG_END])
		Delay(5)
		SetGadgetAttrsA(but3,w,0,[GA_DISABLED,FALSE,TAG_END])
		Delay(5)
		SetGadgetAttrsA(but4,w,0,[GA_DISABLED,FALSE,TAG_END])
*/
	REPEAT
		class:=WaitIMessage(w)
		code:=MsgCode()
		qual:=MsgQualifier()
		iaddr:=MsgIaddr()
		WriteF('class=\z\d[10] code=\z\d[10] qual=\z\d[10] iaddr=\z\d[10] \n',class,code,qual,iaddr)
	UNTIL class=IDCMP_CLOSEWINDOW
	ENDIF
	ENDIF
EXCEPT DO
	IF objlist
		DisposeObjects(objlist)
		DisposeObjectNodes(objlist)
 		Dispose(objlist)
 	ENDIF
 	IF objlist2 THEN DisposePalette(objlist2)
	IF objlist3
		DisposeObjects(objlist3)
		DisposeObjectNodes(objlist3)
 		Dispose(objlist3)
 	ENDIF
	IF objlist4
		DisposeObjects(objlist4)
		DisposeObjectNodes(objlist4)
 		Dispose(objlist4)
 	ENDIF
 	IF mchunk THEN DisposeObject(mchunk)
 	IF scr THEN UnlockPubScreen(0,scr)
	IF propg7 THEN DisposeObject(propg7)
	IF propg6 THEN DisposeObject(propg6)
	IF propg5 THEN DisposeObject(propg5)
	IF propg4 THEN DisposeObject(propg4)
	IF propg3 THEN DisposeObject(propg3)
	IF propg2 THEN DisposeObject(propg2)
	IF propg THEN DisposeObject(propg)
	IF model THEN DisposeObject(model)	-> Will also dispose p2i* and p2b* icclass objects
	IF but1 THEN DisposeObject(but1)
	IF but2 THEN DisposeObject(but2)
	IF but3 THEN DisposeObject(but3)
	IF but4 THEN DisposeObject(but4)
	IF integer1 THEN DisposeObject(integer1)
	IF integer2 THEN DisposeObject(integer2)
	IF integer3 THEN DisposeObject(integer3)
	IF integer4 THEN DisposeObject(integer4)

	IF rkmbutcl THEN FreePopUpClass(rkmbutcl)
	IF chunkyimage_class THEN Free_chunkyiclass(chunkyimage_class)
	IF w THEN CloseWindow(w)
	IF utilitybase THEN CloseLibrary(utilitybase)
	IF chunkyimagebase THEN CloseLibrary(chunkyimagebase)
	IF popupbase THEN CloseLibrary(popupbase)
	FOR i:=0 TO 249
		IF bases[i] THEN CloseLibrary(bases[i])
	ENDFOR
ENDPROC

imagedata:
LONG 29,24
CHAR	$3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$1,$1,$1,$1,$1,$1,$1,$C,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$2,$2,$2,$1,$1,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$1,$1,$2,$2,$1,$D,$1,$1,$1,$1,$1,$1,$14,$1,$1,$1,$1,$1,$1,$1,$1C,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$1,$1,$2,$2,$1,$1,$1,$2,$2,$2,$2,$1,$1,$1,$2,$2,$2,$2,$2,$1,$1,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$2,$2,$2,$1,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$1,$1,$1,$1,$C,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$1,$9,$A,$B,$C,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$2,$2,$2,$1,$1,$1D,$1E,$1F,
           $3,$4,$1,$2,$2,$1,$9,$A,$B,$C,$1,$1,$2,$2,$2,$2,$1,$1,$1,$2,$2,$1,$1,$1,$1,$1C,$1D,$1E,$1F,
           $3,$4,$1,$1,$1,$1,$9,$A,$B,$C,$D,$1,$1,$1,$1,$1,$1,$14,$1,$2,$2,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$11,$12,$13,$14,$1,$1,$1,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$1,$1,$1,$1,$1,$1,$1,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$1,$1,$1,$1,$1,$1,$1,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$2,$2,$2,$1,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$2,$2,$1,$1,$2,$2,$1,$1,$2,$2,$2,$2,$2,$1,$1,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$1,$1,$2,$2,$2,$2,$1,$1,$1,$2,$2,$1,$1,$1,$1,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$1,$1,$1,$1,$1,$1,$10,$1,$2,$2,$1,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$1,$1,$1,$1,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
           $3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$D,$E,$F,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F


palette:
LONG 32,$95959595,$95959595,$95959595,$00000000,$00000000,$00000000,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,
				$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$25252525,$00000000,$FFFFFFFF,$4A4A4A4A,$00000000,
				$FFFFFFFF,$6F6F6F6F,$00000000,$FFFFFFFF,$93939393,$00000000,$FFFFFFFF,$B7B7B7B7,$00000000,
				$FFFFFFFF,$DBDBDBDB,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$80808080,$FFFFFFFF,$00000000,
				$00000000,$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$3F3F3F3F,$00000000,$FFFFFFFF,$7F7F7F7F,
				$00000000,$FFFFFFFF,$BFBFBFBF,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$CCCCCCCC,$FFFFFFFF,
				$00000000,$99999999,$FFFFFFFF,$00000000,$66666666,$FFFFFFFF,$00000000,$33333333,$FFFFFFFF,
				$00000000,$00000000,$FFFFFFFF,$33333333,$00000000,$FFFFFFFF,$66666666,$00000000,$FFFFFFFF,
				$99999999,$00000000,$FFFFFFFF,$CCCCCCCC,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$FFFFFFFF,
				$FFFFFFFF,$00000000,$CCCCCCCC,$FFFFFFFF,$00000000,$99999999,$FFFFFFFF,$00000000,$66666666,
				$FFFFFFFF,$00000000,$33333333,$FFFFFFFF,$00000000,$00000000

mimagedata1:
LONG 68,33
CHAR			 $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,
           $0,$8,$0,$0,$0,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$0,$0,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$0,$0,$0,$0,$0,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$8,$0,$0,$0,$0,$0,$8,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$9,$0,$0,$0,$0,$0,$9,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$A,$0,$0,$0,$0,$0,$A,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$8,$0,$0,$0,$0,$0,$8,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$9,$0,$0,$0,$0,$0,$9,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$A,$0,$0,$0,$0,$0,$A,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$8,$0,$0,$0,$8,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$9,$0,$0,$0,$9,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$A,$0,$0,$0,$A,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$8,$0,$0,$0,$8,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$9,$0,$0,$0,$9,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$A,$0,$0,$0,$A,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$0,$8,$0,$8,$0,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$0,$9,$0,$9,$0,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$0,$A,$0,$A,$0,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$0,$8,$0,$8,$0,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$0,$9,$0,$9,$0,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$0,$A,$0,$A,$0,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$0,$0,$8,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$0,$8,$0,$0,$8,$0,$0,$0,$9,$0,$0,$0,$9,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$0,$9,$0,$0,$9,$0,$0,$0,$A,$0,$0,$0,$A,$0,$0,$0,$A,$0,$0,$A,$0,$0,$0,$0,$A,$0,$0,$A,$0,
           $0,$8,$0,$0,$0,$8,$0,$0,$0,$8,$0,$0,$0,$8,$8,$8,$8,$0,$0,$0,$8,$0,$0,$0,$9,$0,$0,$0,$9,$0,$0,$0,$9,$0,$0,$0,$9,$9,$9,$9,$0,$0,$0,$9,$0,$0,$0,$A,$0,$0,$0,$A,$0,$0,$0,$A,$0,$0,$0,$A,$A,$A,$A,$0,$0,$0,$A,$0,
           $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,
           $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,
           $0,$2,$0,$0,$0,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$0,$0,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$0,$0,$0,$0,$0,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$2,$0,$0,$0,$0,$0,$2,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$1,$0,$0,$0,$0,$0,$1,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$B,$0,$0,$0,$0,$0,$B,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$2,$0,$0,$0,$0,$0,$2,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$1,$0,$0,$0,$0,$0,$1,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$B,$0,$0,$0,$0,$0,$B,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$2,$0,$0,$0,$2,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$1,$0,$0,$0,$1,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$B,$0,$0,$0,$B,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$2,$0,$0,$0,$2,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$1,$0,$0,$0,$1,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$B,$0,$0,$0,$B,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$0,$2,$0,$2,$0,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$0,$1,$0,$1,$0,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$0,$B,$0,$B,$0,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$0,$2,$0,$2,$0,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$0,$1,$0,$1,$0,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$0,$B,$0,$B,$0,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$0,$0,$2,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$0,$2,$0,$0,$2,$0,$0,$0,$1,$0,$0,$0,$1,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$0,$1,$0,$0,$1,$0,$0,$0,$B,$0,$0,$0,$B,$0,$0,$0,$B,$0,$0,$B,$0,$0,$0,$0,$B,$0,$0,$B,$0,
           $0,$2,$0,$0,$0,$2,$0,$0,$0,$2,$0,$0,$0,$2,$2,$2,$2,$0,$0,$0,$2,$0,$0,$0,$1,$0,$0,$0,$1,$0,$0,$0,$1,$0,$0,$0,$1,$1,$1,$1,$0,$0,$0,$1,$0,$0,$0,$B,$0,$0,$0,$B,$0,$0,$0,$B,$0,$0,$0,$B,$B,$B,$B,$0,$0,$0,$B,$0,
           $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,
           $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,
           $0,$E,$0,$0,$0,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$0,$0,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$0,$0,$0,$0,$0,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$E,$0,$0,$0,$0,$0,$E,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$D,$0,$0,$0,$0,$0,$D,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$C,$0,$0,$0,$0,$0,$C,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$E,$0,$0,$0,$0,$0,$E,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$D,$0,$0,$0,$0,$0,$D,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$C,$0,$0,$0,$0,$0,$C,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$E,$0,$0,$0,$E,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$D,$0,$0,$0,$D,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$C,$0,$0,$0,$C,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$E,$0,$0,$0,$E,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$D,$0,$0,$0,$D,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$C,$0,$0,$0,$C,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$0,$E,$0,$E,$0,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$0,$D,$0,$D,$0,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$0,$C,$0,$C,$0,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$0,$E,$0,$E,$0,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$0,$D,$0,$D,$0,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$0,$C,$0,$C,$0,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$0,$0,$E,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$0,$E,$0,$0,$E,$0,$0,$0,$D,$0,$0,$0,$D,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$0,$D,$0,$0,$D,$0,$0,$0,$C,$0,$0,$0,$C,$0,$0,$0,$C,$0,$0,$C,$0,$0,$0,$0,$C,$0,$0,$C,$0,
           $0,$E,$0,$0,$0,$E,$0,$0,$0,$E,$0,$0,$0,$E,$E,$E,$E,$0,$0,$0,$E,$0,$0,$0,$D,$0,$0,$0,$D,$0,$0,$0,$D,$0,$0,$0,$D,$D,$D,$D,$0,$0,$0,$D,$0,$0,$0,$C,$0,$0,$0,$C,$0,$0,$0,$C,$0,$0,$0,$C,$C,$C,$C,$0,$0,$0,$C,$0,
           $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0


mcolordata:
LONG 16,$95959595,$95959595,$95959595,$00000000,$00000000,$00000000,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$3B3B3B3B,$67676767,$A2A2A2A2,$7B7B7B7B,$7B7B7B7B,$7B7B7B7B,$AFAFAFAF,$AFAFAFAF,$AFAFAFAF,$AAAAAAAA,$90909090,$7C7C7C7C,$FFFFFFFF,$A9A9A9A9,$97979797,$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$7E7E7E7E,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$00000000,$FFFFFFFF,$FFFFFFFF,$00000000,$FFFFFFFF,$CCCCCCCC,$CCCCCCCC,$CCCCCCCC


mimagedata2:
LONG 68,33
CHAR			 $8,$8,$8,$0,$0,$0,$0,$0,$8,$8,$8,$8,$8,$8,$0,$0,$8,$8,$8,$8,$8,$8,$0,$9,$9,$9,$0,$0,$0,$0,$0,$9,$9,$9,$9,$9,$9,$0,$0,$9,$9,$9,$9,$9,$9,$0,$A,$A,$A,$0,$0,$0,$0,$0,$A,$A,$A,$A,$A,$A,$0,$0,$A,$A,$A,$A,$A,$A,
           $8,$0,$8,$8,$0,$0,$0,$8,$8,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$9,$0,$0,$0,$9,$9,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$A,$0,$0,$0,$A,$A,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$0,$8,$0,$0,$0,$8,$0,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$0,$9,$0,$0,$0,$9,$0,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$0,$A,$0,$0,$0,$A,$0,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$0,$8,$8,$0,$8,$8,$0,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$0,$9,$9,$0,$9,$9,$0,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$0,$A,$A,$0,$A,$A,$0,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$0,$8,$0,$8,$0,$8,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$0,$9,$0,$9,$0,$9,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$0,$A,$0,$A,$0,$A,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$0,$8,$8,$8,$0,$8,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$0,$9,$9,$9,$0,$9,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$0,$A,$A,$A,$0,$A,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$8,$0,$8,$0,$8,$8,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$9,$0,$9,$0,$9,$9,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$A,$0,$A,$0,$A,$A,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$8,$0,$8,$0,$8,$8,$0,$8,$8,$0,$8,$0,$0,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$9,$0,$9,$0,$9,$9,$0,$9,$9,$0,$9,$0,$0,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$A,$0,$A,$0,$A,$A,$0,$A,$A,$0,$A,$0,$0,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$8,$8,$0,$8,$8,$8,$0,$8,$8,$0,$8,$8,$8,$8,$0,$8,$8,$0,$8,$0,$9,$0,$9,$9,$9,$0,$9,$9,$9,$0,$9,$9,$0,$9,$9,$9,$9,$0,$9,$9,$0,$9,$0,$A,$0,$A,$A,$A,$0,$A,$A,$A,$0,$A,$A,$0,$A,$A,$A,$A,$0,$A,$A,$0,$A,
           $8,$0,$8,$0,$8,$0,$8,$0,$8,$0,$8,$8,$8,$0,$0,$0,$0,$8,$8,$8,$0,$8,$0,$9,$0,$9,$0,$9,$0,$9,$0,$9,$0,$9,$9,$9,$0,$0,$0,$0,$9,$9,$9,$0,$9,$0,$A,$0,$A,$0,$A,$0,$A,$0,$A,$0,$A,$A,$A,$0,$0,$0,$0,$A,$A,$A,$0,$A,
           $8,$8,$8,$0,$8,$8,$8,$0,$8,$8,$8,$0,$8,$8,$8,$8,$8,$8,$0,$8,$8,$8,$0,$9,$9,$9,$0,$9,$9,$9,$0,$9,$9,$9,$0,$9,$9,$9,$9,$9,$9,$0,$9,$9,$9,$0,$A,$A,$A,$0,$A,$A,$A,$0,$A,$A,$A,$0,$A,$A,$A,$A,$A,$A,$0,$A,$A,$A,
           $2,$2,$2,$0,$0,$0,$0,$0,$2,$2,$2,$2,$2,$2,$0,$0,$2,$2,$2,$2,$2,$2,$0,$1,$1,$1,$0,$0,$0,$0,$0,$1,$1,$1,$1,$1,$1,$0,$0,$1,$1,$1,$1,$1,$1,$0,$B,$B,$B,$0,$0,$0,$0,$0,$B,$B,$B,$B,$B,$B,$0,$0,$B,$B,$B,$B,$B,$B,
           $2,$0,$2,$2,$0,$0,$0,$2,$2,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$1,$0,$0,$0,$1,$1,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$B,$0,$0,$0,$B,$B,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$0,$2,$0,$0,$0,$2,$0,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$0,$1,$0,$0,$0,$1,$0,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$0,$B,$0,$0,$0,$B,$0,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$0,$2,$2,$0,$2,$2,$0,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$0,$1,$1,$0,$1,$1,$0,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$0,$B,$B,$0,$B,$B,$0,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$0,$2,$0,$2,$0,$2,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$0,$1,$0,$1,$0,$1,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$0,$B,$0,$B,$0,$B,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$0,$2,$2,$2,$0,$2,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$0,$1,$1,$1,$0,$1,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$0,$B,$B,$B,$0,$B,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$2,$0,$2,$0,$2,$2,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$1,$0,$1,$0,$1,$1,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$B,$0,$B,$0,$B,$B,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$2,$0,$2,$0,$2,$2,$0,$2,$2,$0,$2,$0,$0,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$1,$0,$1,$0,$1,$1,$0,$1,$1,$0,$1,$0,$0,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$B,$0,$B,$0,$B,$B,$0,$B,$B,$0,$B,$0,$0,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$2,$2,$0,$2,$2,$2,$0,$2,$2,$0,$2,$2,$2,$2,$0,$2,$2,$0,$2,$0,$1,$0,$1,$1,$1,$0,$1,$1,$1,$0,$1,$1,$0,$1,$1,$1,$1,$0,$1,$1,$0,$1,$0,$B,$0,$B,$B,$B,$0,$B,$B,$B,$0,$B,$B,$0,$B,$B,$B,$B,$0,$B,$B,$0,$B,
           $2,$0,$2,$0,$2,$0,$2,$0,$2,$0,$2,$2,$2,$0,$0,$0,$0,$2,$2,$2,$0,$2,$0,$1,$0,$1,$0,$1,$0,$1,$0,$1,$0,$1,$1,$1,$0,$0,$0,$0,$1,$1,$1,$0,$1,$0,$B,$0,$B,$0,$B,$0,$B,$0,$B,$0,$B,$B,$B,$0,$0,$0,$0,$B,$B,$B,$0,$B,
           $2,$2,$2,$0,$2,$2,$2,$0,$2,$2,$2,$0,$2,$2,$2,$2,$2,$2,$0,$2,$2,$2,$0,$1,$1,$1,$0,$1,$1,$1,$0,$1,$1,$1,$0,$1,$1,$1,$1,$1,$1,$0,$1,$1,$1,$0,$B,$B,$B,$0,$B,$B,$B,$0,$B,$B,$B,$0,$B,$B,$B,$B,$B,$B,$0,$B,$B,$B,
           $E,$E,$E,$0,$0,$0,$0,$0,$E,$E,$E,$E,$E,$E,$0,$0,$E,$E,$E,$E,$E,$E,$0,$D,$D,$D,$0,$0,$0,$0,$0,$D,$D,$D,$D,$D,$D,$0,$0,$D,$D,$D,$D,$D,$D,$0,$C,$C,$C,$0,$0,$0,$0,$0,$C,$C,$C,$C,$C,$C,$0,$0,$C,$C,$C,$C,$C,$C,
           $E,$0,$E,$E,$0,$0,$0,$E,$E,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$D,$0,$0,$0,$D,$D,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$C,$0,$0,$0,$C,$C,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$0,$E,$0,$0,$0,$E,$0,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$0,$D,$0,$0,$0,$D,$0,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$0,$C,$0,$0,$0,$C,$0,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$0,$E,$E,$0,$E,$E,$0,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$0,$D,$D,$0,$D,$D,$0,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$0,$C,$C,$0,$C,$C,$0,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$0,$E,$0,$E,$0,$E,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$0,$D,$0,$D,$0,$D,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$0,$C,$0,$C,$0,$C,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$0,$E,$E,$E,$0,$E,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$0,$D,$D,$D,$0,$D,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$0,$C,$C,$C,$0,$C,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$E,$0,$E,$0,$E,$E,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$D,$0,$D,$0,$D,$D,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$C,$0,$C,$0,$C,$C,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$E,$0,$E,$0,$E,$E,$0,$E,$E,$0,$E,$0,$0,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$D,$0,$D,$0,$D,$D,$0,$D,$D,$0,$D,$0,$0,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$C,$0,$C,$0,$C,$C,$0,$C,$C,$0,$C,$0,$0,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$E,$E,$0,$E,$E,$E,$0,$E,$E,$0,$E,$E,$E,$E,$0,$E,$E,$0,$E,$0,$D,$0,$D,$D,$D,$0,$D,$D,$D,$0,$D,$D,$0,$D,$D,$D,$D,$0,$D,$D,$0,$D,$0,$C,$0,$C,$C,$C,$0,$C,$C,$C,$0,$C,$C,$0,$C,$C,$C,$C,$0,$C,$C,$0,$C,
           $E,$0,$E,$0,$E,$0,$E,$0,$E,$0,$E,$E,$E,$0,$0,$0,$0,$E,$E,$E,$0,$E,$0,$D,$0,$D,$0,$D,$0,$D,$0,$D,$0,$D,$D,$D,$0,$0,$0,$0,$D,$D,$D,$0,$D,$0,$C,$0,$C,$0,$C,$0,$C,$0,$C,$0,$C,$C,$C,$0,$0,$0,$0,$C,$C,$C,$0,$C,
           $E,$E,$E,$0,$E,$E,$E,$0,$E,$E,$E,$0,$E,$E,$E,$E,$E,$E,$0,$E,$E,$E,$0,$D,$D,$D,$0,$D,$D,$D,$0,$D,$D,$D,$0,$D,$D,$D,$D,$D,$D,$0,$D,$D,$D,$0,$C,$C,$C,$0,$C,$C,$C,$0,$C,$C,$C,$0,$C,$C,$C,$C,$C,$C,$0,$C,$C,$C
